//SpracheWechseln_509d.js
// 24.04.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Wechseln der verwendeten Sprache 
//in geffneten Dokumenten oder in Dokumenten im gewhlten Ordner

// die Listen der verfgbaren Sprachen
var allLang = app.languagesWithVendors;
var lngNameList = app.languagesWithVendors.everyItem().name;
var locLangList = app.languagesWithVendors.everyItem().name;
// sortieren
locLangList.sort(
	function(a, b) {
		if (a.toLowerCase() < b.toLowerCase()) return -1;
		if (a.toLowerCase() > b.toLowerCase()) return 1;
		return 0;
	}
);
// der Name von "Keine Sprache"
var noLang = locLangList[0];

// die Datei lesen, in welcher die zuletzt angewendete Sprache gespeichert ist
var curLang = 0;
if ($.os.slice(0,7) == "Windows") {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/curLang.txt");
}
else {
	var f = new File("~/Library/Preferences/curLang.txt");
}
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		curLang = (f.read())*1;
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist (wenn nicht: den Ordner-Auswahldialog zeigen)
var nDocs = app.documents.length;
if (nDocs == 0) {
	var folderObj = File (Folder.selectDialog("Den Ordner whlen, welcher die InDesign-Dokumente enthlt."));
	var testObj = "" + folderObj;
	if (testObj.match("null")) {
		exit();
	}
	// die Funktion aufrufen, welche die Wahl der neuen Sprache anzeigt
	var dialogIndex = askUser();
	var newLang = getLang(lngNameList, locLangList, dialogIndex);
	// eventuelle Dialoge wegen fehlender Bilder und Schriften ausschalten
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	// den Inhalt des Ordners auflisten
	var allFiles = folderObj.getFiles();
	
	// eine Schleife durch die Dateien
	var curName;
	for (var i=0; i<allFiles.length; i++) {
		curName = allFiles[i].name;
		if (curName.match(".indd")) {
			try {
				// die aktuelle Datei ffnen
				app.open(File (allFiles[i]));
				changeLanguage(newLang);
				app.activeDocument.close(SaveOptions.yes);
			}
			catch (e) {
			}
		}
	}
	// die Dialoge wieder einschalten
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
}
else {
	var dialogIndex = askUser();
	var newLang = getLang(lngNameList, locLangList, dialogIndex);
	var docRef = new Array();
	for (var i=0; i<nDocs; i++) {
		docRef.push(app.documents[i].name);
	}
	var okay = true;
	var docName;
	for (var i=0; i<docRef.length; i++) {
		app.activeDocument = app.documents.item(docRef[i]);
		docName = app.activeDocument.name;
		if (nDocs>1 && i>0) {
			okay = confirm ("Die Sprache dieses Dokuments ndern?\n\n" + docName);
		}
		if (okay) {
			changeLanguage(newLang);
		}
	}
	app.activeDocument = app.documents.item(docRef[0]);
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(1500);
// das Fenster schliessen
dlog.close();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Auswahl der neuen Sprache ermglicht //////////////////////////////////
function askUser() {
	// einen Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Sprache wechseln", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Neue Sprache:", minWidth:80});
				staticTexts.add({staticLabel:"", minWidth:20});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var langName = dropdowns.add({stringList:locLangList, selectedIndex:curLang, minWidth:130});
				}
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:4});
			}
		}
	}
	
	// den Dialog anzeigen, die Wahl des Anwenders speichern
	if (aDialog.show() == true) {
		var dialogIndex = langName.selectedIndex;
		aDialog.destroy();
	}
	else {
		aDialog.destroy();
		exit();
	}
	
	// die Nummer der Sprache in die Datei schreiben
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/curLang.txt");
	}
	else {
		var f = new File("~/Library/Preferences/curLang.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(dialogIndex);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return dialogIndex;
}

// die Funktion zum Bestimmen der Sprache /////////////////////////////////////////////////////////
function getLang(lngNameList, locLangList, dialogIndex) {
	for (var i=0; i<lngNameList.length; i++) {
		if (lngNameList[i] == locLangList[dialogIndex]) {
			return i;
		}
	}
}

// die Funktion zum Wechseln der Sprache //////////////////////////////////////////////////////////
function changeLanguage(newLang) {
	// die Sprache der Absatzformate wechseln
	var curLang;
	var nParaStyles = app.documents[0].paragraphStyles.length;
	for (var i=1; i<nParaStyles; i++) {
		try {
			curLang = app.documents[0].paragraphStyles[i].appliedLanguage.name;
			if (curLang != noLang) {
				app.documents[0].paragraphStyles[i].appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
	
	// die Sprache der Absatzformate der Gruppen wechseln
	var curGroups = app.documents[0].paragraphStyleGroups;
	var nParaStyleGroups = curGroups.length;
	for (var i=0; i<nParaStyleGroups; i++) {
		var curGroup = curGroups[i];
		var curParaStyles = curGroup.allParagraphStyles;
		var nParaStyles = curParaStyles.length;
		for (var k=0; k<nParaStyles; k++) {
			try {
				curLang = curParaStyles[k].appliedLanguage.name;
				if (curLang != noLang) {
					curParaStyles[k].appliedLanguage = allLang[newLang];
				}
			}
			catch (e) {
			}
		}
	}
	
	// die Sprache der Zeichenformate wechseln
	nCharStyles = app.documents[0].characterStyles.length;
	for (var i=1; i<nCharStyles; i++) {
		try {
			curLang = app.documents[0].characterStyles[i].appliedLanguage.name;
			if (curLang != noLang) {
				app.documents[0].characterStyles[i].appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
	
	// die Sprache der Zeichenformate der Gruppen wechseln
	curGroups = app.documents[0].characterStyleGroups;
	var nCharStyleGroups = curGroups.length;
	for (var i=0; i<nCharStyleGroups; i++) {
		var curGroup = curGroups[i];
		var curCharStyles = curGroup.allCharacterStyles;
		var nCharStyles = curCharStyles.length;
		for (var k=0; k<nCharStyles; k++) {
			try {
				curLang = curCharStyles[k].appliedLanguage.name;
				if (curLang != noLang) {
					curCharStyles[k].appliedLanguage = allLang[newLang];
				}
			}
			catch (e) {
			}
		}
	}
	
	// die Sprache der Texte ndern, damit auch solche ohne Format bercksichtigt werden
	app.documents[0].stories.everyItem().appliedLanguage = allLang[newLang];
	
	// die Tabellen auch behandeln
	try {
		app.documents[0].stories.everyItem().tables.everyItem().cells.everyItem().texts[0].appliedLanguage = allLang[newLang];
	}
	catch (e) {
	}
}